%Function to built the Jacobian matrix
function [JAC] = NewtonRaphsonJacobian(nmax,nbb,bustype,PCAL,QCAL,VM,VA,YR,YI);
% JACOBIAN FORMATION
% Include all entries
JAC = zeros(nmax,nmax);
iii = 1;

for ii = 1:nbb
jjj=1;
for jj = 1:nbb
if ii==jj
JAC(iii,jjj) = -QCAL(ii)- VM(ii)^2*YI(ii,ii); 
JAC(iii,jjj+1)= PCAL(ii) + VM(ii)^2*YR(ii,ii); 
JAC(iii+1,jjj) = PCAL(ii) - VM(ii)^2*YR(ii,ii);
JAC(iii+1,jjj+1) = QCAL(ii) - VM(ii)^2*YI(ii,ii);
else
JAC(iii,jjj) = VM(ii)*VM(jj)*(YR(ii,jj)*sin(VA(ii)-VA(jj)) -YI(ii,jj)*cos(VA(ii)-VA(jj))); 
JAC(iii+1,jjj) = -VM(ii)*VM(jj)*(YI(ii, jj)*sin (VA(ii) -VA(jj))+YR(ii,jj)*cos(VA(ii)-VA(jj)));
JAC(iii,jjj+1) = -JAC(iii+1,jjj); 
JAC(iii+1,jjj+1) = JAC(iii,jjj);

end
jjj = jjj + 2;

end
iii=iii +2;
end

% Delete the voltage magnitude and phase angle equations of the slack
% bus and voltage magnitude equations corresponding to PV buses
for kk = 1: nbb
if (bustype(kk) == 1)
ii = kk*2-1;
for jj = 1: 2*nbb 
    if ii == j
JAC(ii, ii) = 1; 
else
JAC(ii,jj) = 0;
JAC(jj,ii) =0; 
end
end
end

if (bustype(kk) == 1) | (bustype(kk) == 2)
ii = kk*2;
for jj = 1: 2 *nbb 
    if ii == j
JAC(ii,ii) = 1; 
else
JAC(ii,jj)= 0;
JAC(jj,ii) = 0; 
end
end
end
end

%End of function NewtonRaphsonJacobian