%Function to calculate the power flows
function [PQsend,PQrec,PQloss,PQbus] = PQflows(nbb,ngn,ntl,nld,genbus,loadbus,tlsend,tlrec,tlresis,tlreac,tlcond,tlsuscep,PLOAD,QLOAD,VM,VA);
PQsend = zeros(1,ntl);
PQrec = zeros(1,ntl);

% Calculate active and reactive powers at the sending and receiving
% ends of tranmsission lines

for ii = 1 : ntl
Vsend = ( VM(tlsend(ii))*cos(VA(tlsend(ii))) + VM(tlsend(ii))*sin(VA(tlsend(ii)))*i );
Vrec = ( VM(tlrec(ii))*cos(VA(tlrec(ii))) + VM(tlrec(ii))*sin(VA(tlrec(ii)))*i );
tlimped = tlresis(ii) + tlreac(ii)*i;
current =(Vsend - Vrec) / tlimped + Vsend* ( tlcond(ii) + tlsuscep(ii)*i )*0.5 ;
PQsend(ii) = Vsend*conj(current);
current =( Vrec - Vsend) / tlimped + Vrec* ( tlcond(ii) + tlsuscep(ii)*i )* 0.5 ;
PQrec(ii) = Vrec*conj(current);
PQloss(ii) = PQsend(ii) + PQrec(ii);

end

% Calculate active and reactive powers injections at buses
PQbus = zeros(1, nbb);
for ii = 1 : ntl
PQbus(tlsend(ii)) = PQbus(tlsend(ii)) + PQsend(ii);
PQbus(tlrec(ii)) = PQbus(tlrec(ii)) + PQrec(ii);
end


%Make corrections at generator buses, where there is load, in order to & get correct generators contributions

for ii = 1 : nld
jj = loadbus(ii);
for kk = 1: ngn
II =genbus(kk);

if jj==II
PQbus( jj) =PQbus(jj) + ( PLOAD(ii) +QLOAD(ii)*i ); 
end
end
end

%End function PQflows