%Carry out iterative solution using the Newton-Raphson method 
function [VM,VA,it,X] = TCSCNewtonRaphson(tol,itmax,ngn,nld,nbb,bustype, genbus,loadbus,PGEN,QGEN,QMAX,QMIN,PLOAD,QLOAD,YR,YI,VM,VA,NTCSC, TCSCsend, TCSCrec,X,XLo,XHi,Flow, Psp,PSta,PNET,QNET,PCAL,QCAL);

% GENERAL SETTINGS 
flag = 0 ;
it = 1;

% CALCULATE NET POWERS 
[PNET,QNET]=NetPowers(nbb,ngn,nld,genbus,loadbus,PGEN,QGEN,PLOAD,QLOAD)

while ( it < itmax & flag==0 )
% CALCULATED POWERS 
[PCAL,QCAL] = CalculatedPowers(nbb,VM,VA,YR,YI)

% CALCULATED TCSC POWERS
[TCSC_PQsend,TCSC_PQrec,PCAL,QCAL] = TCSCCalculatedpower(nbb,VA,VM,NTCSC,TCSCsend,TCSCrec,X,PCAL,QCAL);


% POWER MISMATCHES 
[DPQ,DP,DQ,flag]=PowerMismatches(nbb,tol,bustype,flag,PNET,QNET,PCAL,QCAL);


% TCSC POWER MISMATCHES 
it = 1;
[DPQ,flag]=TCSCPowerMismatches(flag,tol,nbb,DPQ,VM,VA,NTCSC,TCSCsend,TCSCrec,X,Flow,it,Psp,PSta);

%Check for convergence 
if flag == 1
   break
end

% JACOBIAN FORMATION 
[JAC]=NewtonRaphsonJacobian(nbb,bustype,PCAL,QCAL,DPQ,VM,VA,YR,YI);

% MODIFICATION THE JACOBIAN FOR TCSC 
[JAC]=TCSCJacobian(nbb,JAC,VM,VA,NTCSC,TCSCsend,TCSCrec,X,Flow,PSta,it);

%SOLVE JOCOBIAN
D = JAC \ DPQ' ;
% UPDATE THE STATE VARIABLES VALUES, WITH TRUNCATED CORRECTIONS IF 
% NECESSARY (VM increments < +-0.1 p.u. and VA inrements < +- 5 deg)
[VA,VM]=StateVariablesUpdating(nbb,D,VA,VM,it);

% UPDATE THE TCSC VARIABLES 
[X]=TCSCUpdating(it,nbb,D,NTCSC,X,PSta);

%CHECK IMPEDANCE FOR LIMITS 
[X]=TCSCLimits(NTCSC,X,XLo,XHi,PSta);
it = it + 1;
end