%PROGRAM 5.3 Program written in Matlab to incorporate the thyristor-controlled series compensator (TCSC) 
%variable reactance model within the Newton-Raphson power flow algorithm

% - - - Main TCSC variable reactance

PowerFlowsData; %Function to read network data

TCSCData; %Function to read TCSC variable series reactance

[YR,YI] = YBus(tlsend,tlrec,tlresis,tlreac,tlsuscep,tlcond,ntl,nbb)

[VM,VA,it,X] = TCSCNewtonRaphson(tol,itmax,ngn,nld,nbb,bustype,genbus, loadbus,PGEN,QGEN,QMAX,QMIN,PLOAD,QLOAD,YR,YI,VM,VA,NTCSC, TCSCsend, TCSCrec,X,XLo,XHi,Flow, Psp,PSta)

[PQsend,PQrec,PQloss,PQbus] =PQflows(nbb,ngn,ntl,nld,genbus,loadbus,tlsend,tlrec,tlresis,tlreac,tlcond,tlsuscep,PLOAD,QLOAD,VM,VA);

[Ptcsc,Qtcsc] = TCSCPQflows(nbb,VA,VM,NTCSC,TCSCsend,TCSCrec,X);

%Print results

it	%Number of iterations
VM	%Nodal voltage magnitude (p.u) 
VA=VA*180/pi %Nodal voltage phase angles (Deg)
Ptcsc	%Active power flow in TCSC (p.u.)
Qtcsc	%Reactive power flow in TCSC (p.u.)
X	%Final reactance value (p.u.)

%End of TCSC MAIN PROGRAM


